<template>
  <div class="row justify-content-center">
    <div class="col-md-6">
      <h1>Edit</h1>
      <a-form-model
        ref="ruleForm"
        :model="user"
        :rules="rules"
        :label-col="labelCol"
        :wrapper-col="wrapperCol"
      >
        <a-form-model-item ref="name" label="Name" prop="name">
          <a-input v-model="user.name" />
        </a-form-model-item>

        <a-form-model-item label="Email" prop="email">
          <a-input v-model="user.email" />
        </a-form-model-item>

        <a-form-model-item label="Phone" prop="phone">
          <a-input :max-length="10" v-model="user.phone" />
        </a-form-model-item>

        <a-form-model-item label="Birth date" prop="birthdate">
          <a-date-picker
            v-model="user.birthdate"
            type="date"
            placeholder="Pick a date"
            style="width: 100%"
          />
        </a-form-model-item>

        <a-form-model-item label="Sex" prop="sex">
          <a-radio-group v-model="user.sex">
            <a-radio value="male"> male </a-radio>
            <a-radio value="female"> female </a-radio>
          </a-radio-group>
        </a-form-model-item>

        <a-form-model-item label="Address" prop="address">
          <a-input v-model="user.address" type="textarea" />
        </a-form-model-item>

        <a-form-model-item label="Company" prop="company">
          <a-select
            v-model="user.company"
            placeholder="please select your zone"
          >
            <a-select-option value="Zone one"> Zone one </a-select-option>
            <a-select-option value="Zone two"> Zone two </a-select-option>
          </a-select>
        </a-form-model-item>

        <a-form-model-item :wrapper-col="{ span: 14, offset: 4 }">
          <a-button type="primary" @click="handleEditForm"> Edit </a-button>
          <a-button style="margin-left: 10px" @click="back"> Back </a-button>
        </a-form-model-item>
      </a-form-model>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import AppConfig from "../../utils/config";

export default {
  data() {
    return {
      user: {},
      rules: {
        name: [
          {
            required: true,
            message: "Please input your name!",
            whitespace: true,
            trigger: "change",
          },
        ],
        email: [
          {
            type: "email",
            message: "The input is not valid E-mail!",
          },
          {
            required: true,
            message: "Please input your E-mail!",
            trigger: "change",
          },
        ],
        phone: [
          { required: true, message: 'Please input your Phone!', trigger: 'change' },
          { min: 10, message: 'Length should be 10', trigger: 'change' },
        ],
      },
    };
  },
  created() {
    let api = AppConfig.config().api_url;
    let apiURL = api + `/api/user/${this.$route.params.id}`;
    console.log(apiURL);
    axios
      .get(apiURL)
      .then((res) => {
        this.user = res.data.resultData;
        console.log(res.data);
      })
      .catch((error) => {
        console.log(error);
      });
  },
  methods: {
    handleEditForm() {
      this.$refs.ruleForm.validate((valid) => {
        console.log("valid", valid);
        if (valid) {
          let api = AppConfig.config().api_url;
          let apiURL = api + `/api/user/update/${this.$route.params.id}`;

          axios
            .put(apiURL, this.user)
            .then(() => {
              this.$router.push("/");
            })
            .catch((error) => {
              console.log(error);
            });
        } else {
          console.log("error submit!!");
          return false;
        }
      });
    },
    back() {
      this.$router.push("/");
    },
  },
};
</script>

<style></style>
